(in-package :custom)
(use-package :oli)

(sd-am-create-symbol-dialog
      :name "SYMBOL_KANTE"
      :title "Werkstueckkante"
      :variables
      		(
		  ("Werkstueckkanten DIN6784")
      		  (PICTURE :value-type :image
                           :image-file (format nil "~a/pixmaps/symbol_werkstueckkante.xpm" (oli::sd-sys-getenv "SDSYMCUSTOMIZEDIR"))
      		  	   :image-width 90
      		  	   :image-height 44
      		  	   :initial-optional t
      		  ) 	   
      		  ("-")
      		  (GELTUNGSBER :expand-shrink ((AUSRICHTUNG A B C D) (SYMBOLART A B C D))
      		               :expand-shrink-range ( (local :label "Local")
      		       	                              (global :label "Global") 
      		       		                    )
      		  )
      		  ("-")
		  (SYMBOLART :range ((1 :label "Aussenkante")
      		  	 	     (2 :label "Innenkante")
      		  		     (3 :label "Allgemein")
      		  	     
      		  	            		  		    )
  		  )
      		  (AUSRICHTUNG :range ((1 :pixmap-file (format nil "~a/pixmaps/symbol_werkstkante_reob.xpm" (oli::sd-sys-getenv "SDSYMCUSTOMIZEDIR")) ) ;;rechts oben
      		  		       (2 :pixmap-file (format nil "~a/pixmaps/symbol_werkstkante_liob.xpm" (oli::sd-sys-getenv "SDSYMCUSTOMIZEDIR")) ) ;;links oben
      		  		       (3 :pixmap-file (format nil "~a/pixmaps/symbol_werkstkante_reun.xpm" (oli::sd-sys-getenv "SDSYMCUSTOMIZEDIR")) ) ;;rechts unten
      		  		       (4 :pixmap-file (format nil "~a/pixmaps/symbol_werkstkante_liun.xpm" (oli::sd-sys-getenv "SDSYMCUSTOMIZEDIR")) ) ;;links unten
      		  		      )
      		  )
      		  ("-")
      		  (A :value-type :string
      		     :title "a"
      		     :initial-optional t
      		     :initial-value ""
      		  )
      		  (B :value-type :string
      		     :title "b"
      		     :initial-optional t
      		     :initial-value ""
      		  )
      		  (C :value-type :string
      		     :title "c"
      		     :initial-optional t
      		     :initial-value ""
      		  )
      		  (D :value-type :string
      		     :title "d"
      		     :initial-optional t
      		     :initial-value ""
      		  )   		  
      		)  
      		
      :position-prompt "Position fr Symbol waehlen"
      :draw-symbol-command
        (let (geo-settings)
         

          
          ;; Merken der aktuellen Einstellungen fuer Geometrie
          (setf geo-settings (sd-am-inq-curr-geometry-attributes))

          ;; Farbe auf CYAN
          (sd-call-cmds (AM_GEO_DEFAULT :line_type :SOLID :color :rgb 0.0,1.0,1.0))
;;(if ( SYMBOLART 3) (DISPLAY "allg"))
           

         (if (string= GELTUNGSBER "GLOBAL") 
              (progn (setf AUSRICHTUNG 1)
                     (if (= SYMBOLART 3) (setf A "" B "" C "" D "") nil)
              )
              
               nil ) 



          
          (setf pnt_x0 0 pnt_y0 0 line_l 5 text_h 3.5)
          
          ;; Punkte fuer Linien und Texte berechnen
          (case AUSRICHTUNG
                                           
          	(1 (setf pnt_y1 (+ pnt_y0 line_l) pnt_x2 (+ pnt_x0 line_l) 
          	         pnt_ax 1 pnt_ay 1 pnt_by (+ 2 text_h) 
          	         pnt_cx (+ 1 line_l) pnt_cy 0 
          	         pnt_dx 0 pnt_dy (+ 1 line_l) 
          	         text_adj_ab 1 text_adj_c 4 text_adj_d 2
          	   )
                )
          	(2 (setf pnt_y1 (+ pnt_y0 line_l) pnt_x2 (- pnt_x0 line_l) 
          	   	 pnt_ax -1 pnt_ay 1 pnt_by (+ 2 text_h) 
          	   	 pnt_cx (- (+ 1 line_l)) pnt_cy 0
          	   	 pnt_dx 0 pnt_dy (+ 1 line_l) 
          	   	 text_adj_ab 3 text_adj_c 6 text_adj_d 2
          	   )
                )  
          	(3 (setf pnt_y1 (- pnt_y0 line_l) pnt_x2 (+ pnt_x0 line_l) 
          	         pnt_ax 1 pnt_ay (- (+ 1 text_h)) pnt_by (- (+ 2 (* text_h 2)))
          	         pnt_cx (+ 1 line_l) pnt_cy 0 
          	         pnt_dx 0 pnt_dy  (- (+ 1 line_l)) 
          	         text_adj_ab 1 text_adj_c 4 text_adj_d 8
          	   )
                )  
          	(4 (setf pnt_y1 (- pnt_y0 line_l) pnt_x2 (- pnt_x0 line_l) 
          	         pnt_ax -1 pnt_ay (- (+ 1 text_h)) pnt_by (- (+ 2 (* text_h 2)))
          	         pnt_cx (- (+ 1 line_l)) pnt_cy 0
          	         pnt_dx 0 pnt_dy  (- (+ 1 line_l)) 
          	         text_adj_ab 3 text_adj_c 6 text_adj_d 8
          	   )
                )                                            
          )            
          

          
          (sd-call-cmds (AM_TEXT_SETTINGS  :size     text_h :abs_angle 0.0
                                           :slant    0.0 :ratio    0.8
                                           :adjust   1   :frame    "OFF"
                                           :font1b   "hp_i3098_v"))                
          
          ;; erstellen der localen symbole
          (sd-am-create-symbol-line (list (make-gpnt2d :x pnt_x0 :y pnt_y0)
                                          (make-gpnt2d :x pnt_x0 :y pnt_y1)))
          (sd-am-create-symbol-line (list (make-gpnt2d :x pnt_x0 :y pnt_y0)
                                          (make-gpnt2d :x pnt_x2 :y pnt_y0)))
                                          
          (sd-call-cmds (AM_TEXT_SETTINGS :adjust text_adj_ab))                                       
          (sd-am-create-symbol-parameter "a" A :position (make-gpnt2d :x pnt_ax :y pnt_ay))
	  (sd-am-create-symbol-parameter "b" B :position (make-gpnt2d :x pnt_ax :y pnt_by))
          (sd-call-cmds (AM_TEXT_SETTINGS :adjust text_adj_c))                                       
	  (sd-am-create-symbol-parameter "c" C :position (make-gpnt2d :x pnt_cx :y pnt_cy))
          (sd-call-cmds (AM_TEXT_SETTINGS :adjust text_adj_d))                                       
	  (sd-am-create-symbol-parameter "d" D :position (make-gpnt2d :x pnt_dx :y pnt_dy))

	  ;; erstellen der globalen symbole
;	  (case GELTUNGSBER                     ;funktioniert seit version 11 nicht mehr
;	     (GLOBAL          	                ;funktioniert seit version 11 nicht mehr
          (if (string= GELTUNGSBER "GLOBAL")    ;ersatz fr case
	    (progn                              ;ersatz fr case
          	 ;; pfeil erstellen
          	 (sd-call-cmds (AM_GEO_DEFAULT :line_type :SOLID :color :rgb 1.0,1.0,0.0))
          	 (sd-am-create-symbol-line (list (make-gpnt2d :x pnt_x0 :y pnt_y0)
               	                        	 (make-gpnt2d :x -3 :y -3)))          
               	 (sd-am-create-symbol-line (list (make-gpnt2d :x -3 :y -3)
               	                                 (make-gpnt2d :x -2 :y -1.75))) 
               	 (sd-am-create-symbol-line (list (make-gpnt2d :x -2 :y -1.75)
               	                                 (make-gpnt2d :x -1.75 :y -2)))
               	 (sd-am-create-symbol-line (list (make-gpnt2d :x -1.75 :y -2)
               	                                 (make-gpnt2d :x -3 :y -3)))
                 (case SYMBOLART  
                 	(1
                 	   ;; aussenkante erstellen
          		   (sd-call-cmds (AM_GEO_DEFAULT :line_type :SOLID :color :rgb 1.0,1.0,1.0))
 	            	   (sd-am-create-symbol-line (list (make-gpnt2d :x -3 :y -3)
               	                        	           (make-gpnt2d :x -3 :y -8)))          
 	               	   (sd-am-create-symbol-line (list (make-gpnt2d :x -3 :y -3)
               	                                           (make-gpnt2d :x -8 :y -3)))                 			
                 	)
                 	(2
                 	   ;; innenkante erstellen
          		   (sd-call-cmds (AM_GEO_DEFAULT :line_type :SOLID :color :rgb 1.0,1.0,1.0))
 	            	   (sd-am-create-symbol-line (list (make-gpnt2d :x -3 :y -3)
               	                        	           (make-gpnt2d :x -3 :y 2)))          
 	               	   (sd-am-create-symbol-line (list (make-gpnt2d :x -3 :y -3)
               	                                           (make-gpnt2d :x 2 :y -3)))
               	                           			
                 	)
                 	(3
                 	   ;; klammern erstellen
                 	   (sd-call-cmds (AM_GEO_DEFAULT :line_type :SOLID :color :rgb 1.0,1.0,1.0))
                 	   (sd-am-create-symbol-arc (make-gpnt2d :x 1 :y 1)
                 	   			    (make-gpnt2d :x -4.36 :y 5.5)
                 	   			    (make-gpnt2d :x -4.36 :y -3.5))
                 	   (sd-am-create-symbol-arc (make-gpnt2d :x 1 :y 1)
                 	   			    (make-gpnt2d :x 6.36 :y -3.5)
                 	   			    (make-gpnt2d :x 6.36 :y 5.5))			    
                 	)               	
         	 )
         	      
;              )        ;ende case
;          )            ;ende case GLOBAL                                                                                                  	  
            ) ;progn
          nil  ;then
         );if

          ;; Ruecksetzen der Farbe und der Linienart
          (sd-call-cmds (AM_GEO_DEFAULT :color 
          (sd-rgb-to-color (sd-am-geo-attributes-struct-color geo-settings))))
          (sd-call-cmds (AM_GEO_DEFAULT :line_type
          (sd-am-geo-attributes-struct-linetype geo-settings)))
            
          (sd-call-cmds (AM_TEXT_SETTINGS  :size     3.5 :abs_angle 0.0
                                           :slant    0.0 :ratio    0.8
                                           :adjust   1   :frame    "OFF"
                                           :font1b   "hp_i3098_v"))                
          
         )
)




      

